---
title: "FreeBSD 13.4-RELEASE Release Notes"
sidenav: download
---

:releaseCurrent: 13.4-RELEASE
:releaseBranch: 13-STABLE
:releasePrev: 13.3-RELEASE
:releaseNext: 13.5-RELEASE
:releaseType: "release"

include::shared/en/urls.adoc[]

= FreeBSD {releaseCurrent} Release Notes
:doctype: article
:toc: macro
:toclevels: 1
:icons: font

== Abstract

[.abstract-title]
The release notes for FreeBSD {releaseCurrent} contain a summary of the changes made to the FreeBSD base system on the {releaseBranch} development line.
This document lists applicable security advisories that were issued since the last release, as well as significant changes to the FreeBSD kernel and userland.
Some brief remarks on upgrading are also presented.

[[intro]]
== Introduction

This document contains the release notes for FreeBSD {releaseCurrent}.
It describes recently added, changed, or deleted features of FreeBSD.
It also provides some notes on upgrading from previous versions of FreeBSD.

The {releaseType} distribution to which these release notes apply represents the latest point along the {releaseBranch} development branch since {releaseBranch} was created.
Information regarding pre-built, binary {releaseType} distributions along this branch can be found at https://www.FreeBSD.org/releases/[].

The {releaseType} distribution to which these release notes apply represents a point along the {releaseBranch} development branch between {releasePrev} and the future {releaseNext}.
Information regarding pre-built, binary {releaseType} distributions along this branch can be found at https://www.FreeBSD.org/releases/[].

This distribution of FreeBSD {releaseCurrent} is a {releaseType} distribution.
It can be found at https://www.FreeBSD.org/releases/[] or any of its mirrors.
More information on obtaining this (or other) {releaseType} distributions of FreeBSD can be found in the link:{handbook}/mirrors[Obtaining FreeBSD appendix] to the link:{handbook}/[FreeBSD Handbook].

All users are encouraged to consult the release errata before installing FreeBSD.
The errata document is updated with "late-breaking" information discovered late in the release cycle or after the release.
Typically, it contains information on known bugs, security advisories, and corrections to documentation.
An up-to-date copy of the errata for FreeBSD {releaseCurrent} can be found on the FreeBSD Web site.

This document describes the most user-visible new or changed features in FreeBSD since {releasePrev}.
In general, changes described here are unique to the {releaseBranch} branch unless specifically marked as MERGED features.

Typical release note items document recent security advisories issued after {releasePrev}, new drivers or hardware support, new commands or options, major bug fixes, or contributed software upgrades.
They may also list changes to major ports/packages or release engineering practices.
Clearly the release notes cannot list every single change made to FreeBSD between releases; this document focuses primarily on security advisories, user-visible changes, and major architectural improvements.

[[upgrade]]
== Upgrading from Previous Releases of FreeBSD

Binary upgrades between RELEASE versions (and snapshots of the various security branches) are supported using the man:freebsd-update[8] utility.
See the release-specific upgrade procedure, link:../installation/#upgrade-binary[FreeBSD {releaseCurrent} upgrade information], with more details in the FreeBSD handbook link:{handbook}cutting-edge/#freebsdupdate-upgrade[binary upgrade procedure].
This will update unmodified userland utilities, as well as unmodified GENERIC kernels distributed as a part of an official FreeBSD release.
The man:freebsd-update[8] utility requires that the host being upgraded have Internet connectivity.

Source-based upgrades (those based on recompiling the FreeBSD base system from source code) from previous versions are supported, according to the instructions in [.filename]#/usr/src/UPDATING#.

[IMPORTANT]
====
Upgrading FreeBSD should only be attempted after backing up _all_ data and configuration files.
====

[[security-errata]]
== Security and Errata

This section lists the various Security Advisories and Errata Notices since {releasePrev}.

[[security]]
=== Security Advisories

[.informaltable]
[cols="1,1,1", frame="none", options="header"]
|===
| Advisory
| Date
| Topic

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:03.unbound.asc[FreeBSD-SA-24:03.unbound]
|28 March 2024
|Multiple vulnerabilities in Unbound

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:04.openssh.asc[FreeBSD-SA-24:04.openssh]
|01 July 2024
|OpenSSH pre-authentication remote code execution

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:05.pf.asc[FreeBSD-SA-24:05.pf]
|07 August 2024
|pf incorrectly matches different ICMPv6 states in the state table

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:06.ktrace.asc[FreeBSD-SA-24:06.ktrace]
|07 August 2024
|man:ktrace[2] fails to detach when executing a setuid binary

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:07.nfsclient.asc[FreeBSD-SA-24:07.nfsclient]
|07 August 2024
|NFS client accepts file names containing path separators

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:08.openssh.asc[FreeBSD-SA-24:08.openssh]
|07 August 2024
|OpenSSH pre-authentication async signal safety issue

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:09.libnv.asc[FreeBSD-SA-24:09.libnv]
|04 September 2024
|Multiple vulnerabilities in libnv

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:10.bhyve.asc[FreeBSD-SA-24:10.bhyve]
|04 September 2024
|man:bhyve[8] privileged guest escape via TPM device passthrough

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:11.ctl.asc[FreeBSD-SA-24:11.ctl]
|04 September 2024
|Multiple issues in man:ctl[4] CAM Target Layer

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:12.bhyve.asc[FreeBSD-SA-24:12.bhyve]
|04 September 2024
|man:bhyve[8] privileged guest escape via USB controller

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:13.openssl.asc[FreeBSD-SA-24:13.openssl]
|04 September 2024
|Possible DoS in X.509 name checks in OpenSSL

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:14.umtx.asc[FreeBSD-SA-24:14.umtx]
|04 September 2024
|umtx Kernel panic or Use-After-Free
|===

[[errata]]
=== Errata Notices

[.informaltable]
[cols="1,1,1", frame="none", options="header"]
|===
| Errata
| Date
| Topic

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:05.tty.asc[FreeBSD-EN-24:05.tty]
|28 March 2024
|TTY Kernel panic

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:06.wireguard.asc[FreeBSD-EN-24:06.wireguard]
|28 March 2024
|Insufficient barriers in WireGuard man:if_wg[4]

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:07.clang.asc[FreeBSD-EN-24:07.clang]
|28 March 2024
|Clang crash when certain optimization is enabled

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:08.kerberos.asc[FreeBSD-EN-24:08.kerberos]
|28 March 2024
|Kerberos segfaults when using weak crypto

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:09.zfs.asc[FreeBSD-EN-24:09.zfs]
|24 April 2024
|High CPU usage by kernel threads related to ZFS

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:10.zfs.asc[FreeBSD-EN-24:10.zfs]
|19 June 2024
|Kernel memory leak in ZFS

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:11.ldns.asc[FreeBSD-EN-24:11.ldns]
|19 June 2024
|LDNS uses nameserver commented out in resolv.conf

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:12.killpg.asc[FreeBSD-EN-24:12.killpg]
|19 June 2024
|Lock order reversal in killpg causing livelock

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:13.libcpass:[++].asc[FreeBSD-EN-24:13.libc++]
|19 June 2024
|Incorrect size passed to heap allocated std::string delete

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:14.ifconfig.asc[FreeBSD-EN-24:14.ifconfig]
|07 August 2024
|Incorrect ifconfig netmask assignment

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:15.calendar.asc[FreeBSD-EN-24:15.calendar]
|04 September 2024
|man:cron[8] / man:periodic[8] session login
|===

[[userland]]
== Userland

This section covers changes and additions to userland applications, contributed software, and system utilities.

[[userland-programs]]
=== Userland Application Changes

`libcapsicum` has been improved to cache more time zone information.
This change reduces the number of calls to man:tzset[3] and improves performance.

[[userland-contrib]]
=== Contributed Software

`sqlite3` has been upgraded to 3.46.0.

`OpenSSH` has been to upgraded to 9.7p1.
This release contains mostly bugfixes.
It also makes support for the DSA signature algorithm a compile-time option, with plans to disable it upstream later this year and remove support entirely in 2025.

LLVM and the `clang` compiler have been upgraded to version 18.1.5.

`bc` has been updated to version 6.7.6.

`atf` has been updated to 0.22 snapshot 55c21b2c.

`libarchive` has been updated to 3.7.4.

`capsicum-test` has been updated to snapshot eab7a83b.

[[drivers]]
== Devices and Drivers

This section covers changes and additions to devices and device drivers since {releasePrev}.

[[drivers-device]]
=== Device Drivers

The man:irdma[4] driver has been updated.

The man:ice[4] driver has been updated.

Support for SIM7600G has been added to man:u3g[4].

There have been many stability fixes to native and LinuxKPI-based wireless drivers.
(Sponsored by The FreeBSD Foundation)

[[network]]
== Networking

This section describes changes that affect networking in FreeBSD.

[[network-protocols]]
== Network Protocols

Lots of improvements to the network stack, including performance improvements and bug fixes for the man:sctp[4] stack.
Specifically, support for the SCTP checksum offload feature has been added to the loopback interface.

[[hardware]]
== Hardware Support

This section covers general hardware support for physical machines, hypervisors, and virtualization environments, as well as hardware changes and updates that do not otherwise fit in other sections of this document.

Please see link:https://www.freebsd.org/releases/13.4R/hardware[the list of hardware] supported by {releaseCurrent}, as well as link:https://www.freebsd.org/platforms/[the platforms page] for the complete list of supported CPU architectures.

[[processor]]
=== Processor Support

Added support for AMD Ryzen 7 "Phoenix" processors (family 0x19, model 0x70-0x7f) to the man:amdsmn[4] and man:amdtemp[4] drivers.
This enables temperature readings of these CPUs via sysctl.
The sensors function identically to those for the "Raphael" processors (model 0x60-0x6f); only the PCI device ID differs.

[[documentation]]
== Documentation

This section covers changes to manual (man:man[1]) pages and other documentation shipped with the base system.

[[man-pages]]
=== Man Pages

References to the legacy `disklabel` utility have been removed in favour of gpart.
Future FreeBSD releases will remove this tool entirely.

[[ports]]
== Ports Collection and Package Infrastructure

This section covers changes to the FreeBSD Ports Collection, package infrastructure, and package maintenance and installation tools.

[[ports-packages]]
=== Packaging Changes

The DVD package set has been modernized.

package:archivers/unzip[] has been removed as it is in base now.

package:emulators/linux_base-c7[] has been removed as it is unlikely to be useful without other Linux packages being installed.

package:ports-mgmt/portmaster[] has been removed as it has been discouraged in favour of using pkg and binary packages.

package:x11-drivers/xf86-video-vmware[] has been removed as it is no longer useful with the current version of xorg-server.

package:devel/git[] has been replaced with package:devel/git@lite[] as this is sufficient for most purposes.

package:sysutils/seatd[] and package:x11-wm/sway[] have been added for Wayland support.

[[future-releases]]
== General Notes Regarding Future FreeBSD Releases

FreeBSD 15.0 is not expected to include support for 32-bit platforms other than armv7.
The armv6, i386, and powerpc platforms are deprecated and will be removed.
64-bit systems will still be able to run older 32-bit binaries.

The FreeBSD Project expects to support armv7 as a Tier 2 architecture in FreeBSD 15.0 and stable/15.
However, the Project also anticipates that armv7 may be removed in FreeBSD 16.0.
The Project will provide an update on the status of armv7 for both 15.x and 16.x at the time of 15.0 release.

Support for executing 32-bit binaries on 64-bit platforms via the `COMPAT_FREEBSD32` option will continue for at least the stable/15 and stable/16 branches.
Support for compiling individual 32-bit applications via `cc -m32` will also continue for at least the stable/15 branch, which includes suitable headers in [.filename]#/usr/include# and libraries in [.filename]#/usr/lib32#.

Ports will not include support for deprecated 32-bit platforms for FreeBSD 15.0 and later releases.
These future releases will not include binary packages or support for building packages from ports for deprecated 32-bit platforms.

The FreeBSD stable/14 and earlier branches will retain existing 32-bit kernel and world support.
Ports will retain existing support for building ports and packages for 32-bit systems on stable/14 and earlier branches as long as those branches are supported by the ports system.
However, all 32-bit platforms are Tier-2 or Tier-3, and support for individual ports should be expected to degrade as upstreams deprecate 32-bit platforms.

With the current support schedule, stable/14 will reach end of life (EOL) around 5 years after the release of FreeBSD 14.0-RELEASE.
The EOL of stable/14 will mark the end of support for deprecated 32-bit platforms, including source releases, pre-built packages, and support for building applications from ports.
With the release of 14.0-RELEASE in November 2023, support for deprecated 32-bit platforms will end in November 2028.

The Project may choose to alter this approach when FreeBSD 15.0 is released by extending some level of support for one or more of the deprecated platforms in 15.0 or later.
Any alterations will be driven by community feedback and committed efforts to support these platforms.
